//=======================================================================
// quicksort.h : Quick Sort source file
//
// Copyright (c) 2009 Tai-Pang Wu (pang@cse.ust.hk) and HKUST x CUHK
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//======================================================================= 


#include "StdAfx.h"
#include "quicksort.h"

void quickSort(double numbers[], int order[], int array_size)
{
  q_sort(numbers, order, 0, array_size - 1);
}


void q_sort(double numbers[], int order[], int left, int right)
{
  double pivot;
  int pivotOrder;
  int l_hold, r_hold;

  l_hold = left;
  r_hold = right;
  pivot = numbers[left];
  pivotOrder = order[left];
  while (left < right)
  {
    while ((numbers[right] >= pivot) && (left < right))
      right--;
    if (left != right)
    {
      numbers[left] = numbers[right];
	  order[left] = order[right];
      left++;
    }
    while ((numbers[left] <= pivot) && (left < right))
      left++;
    if (left != right)
    {
      numbers[right] = numbers[left];
	  order[right] = order[left];
      right--;
    }
  }
  numbers[left] = pivot;
  order[left] = pivotOrder;
  int temp = left;
  left = l_hold;
  right = r_hold;
  if (left < temp)
    q_sort(numbers, order, left, temp-1);
  if (right > temp)
    q_sort(numbers, order, temp+1, right);
}

